"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const postgres_1 = require("@cuillere/postgres");
exports.CuillerePostgresApolloPlugin = (options, transactionOptions) => {
    var _a;
    const provider = (_a = options.poolProvider) !== null && _a !== void 0 ? _a : new postgres_1.PoolProvider(...options.poolConfigs);
    return ({
        requestDidStart: () => ({
            executionDidStart({ context }) {
                const manager = new postgres_1.TransactionManager(provider, transactionOptions);
                postgres_1.setQueryHandler(context, query => manager.query(query));
                return err => (err ? manager.rollback() : manager.commit());
            },
        }),
    });
};
//# sourceMappingURL=index.js.map